/*
This class provides for all messages sent between C2 Application
and C2 Simulation resources during an system demonstration. This
class is derived from the NPAC message class when instantiated
into the overall framework.

Author:     P. Marshall        VRI
Rev:        0.0A                9/21/96
*/

//import message;   Make extends when integrated into NPAC package

import java.util.Date;

public class C2Message{
    public static final byte ActualDate = 0;
    public static final byte RelativeToDemoStart = 1;
    public static final byte RelativeToDetection = 10;
    public static final byte RelativeToInterceptorLauch = 20;
    public static final byte RelativeToIntercetion = 30;
    public static final byte RelativeToClosing = 40;

    public static final byte SendToAllPlayers = 100;
    public static final byte SendToAllCenters = 101;
    public static final byte SendToAllCivilians = 102;
    public static final byte SendToAllCommanders = 103;
    public static final byte SendToAllNORAD = 104;
    public static final byte SendToSimulation = 120;

    public static final byte participantIsNotImportant = 0;
    public static final byte participantIsNORADCINC = 1;
    public static final byte participantIsNORADADOC = 2;
    public static final byte participantIsUSPresident = 3;
    public static final byte participantIsUSPilot = 4;
    public static final byte participantIsFEMA =  5;
    public static final byte participantIsLocalDoctor =  6;
    public static final byte participantIsDirector = 7;
    public static final byte participantIsOther =  8;
    public static final byte participantIsAWACS =  9;
    public static final byte participantIsFirstROCC=  10;
    public static final byte participantIsSim=  98;
    public static final byte participantIsScript=  99;

    public static final byte MessageDEFCON  = 10;
    public static final byte MessageDEFCON1 = 11;
    public static final byte MessageDEFCON2 = 12;
    public static final byte MessageDEFCON3 = 13;
    public static final byte MessageDEFCON4 = 14;
    public static final byte MessageDEFCON5 = 15;

    public static final byte MessageDEFCONIs  = 20;
    public static final byte MessageDEFCONIs1 = 21;
    public static final byte MessageDEFCONIs2 = 22;
    public static final byte MessageDEFCONIs3 = 23;
    public static final byte MessageDEFCONIs4 = 24;
    public static final byte MessageDEFCONIs5 = 25;

    public static final byte MessageLaunchInterceptors = 7;
    public static final byte MessagePerformIntercept = 8;
    public static final byte MessageRecallInterceptors = 9;
    public static final byte MessageisInternal = 99;



    Date        SimTime;

    boolean     MessageIsSynthetic;
    byte        IntendedParticipant;
    byte        OriginatingParticipant;
    byte        MessageIsFrom;

    public C2Message    (Date time, boolean Synthetic, byte IntendedPart, byte OriginatingPart) {
        super();
        SimTime = time;
        MessageIsSynthetic = Synthetic;
        OriginatingParticipant = OriginatingPart;
        IntendedParticipant = IntendedPart;
    }

    public C2Message    (boolean Synthetic, byte IntendedPart, byte OriginatingPart) {
        super();
        DateStamp();
        MessageIsSynthetic = Synthetic;
        OriginatingParticipant = OriginatingPart;
        IntendedParticipant = IntendedPart;
    }

    public byte getMessageID()  {
        return 0;       //  May be redefined by subclass
    }


    public boolean IsItSynthetic () {
        return MessageIsSynthetic;
    }

    public void MakeItSynthetic ()  {
        MessageIsSynthetic = true;
    }

    public void MakeItNotSynthetic ()  {
        MessageIsSynthetic = false;
    }

    public void SetSynthetic (boolean theFlag)  {
        MessageIsSynthetic = theFlag;
    }

    public byte getParticipant ()    {
        return OriginatingParticipant;
    }

    public void setParticipant (byte participant) {
        OriginatingParticipant = participant;
    }

    public Date getDate()   {
        return SimTime;
    }

    public void DateStamp() {   // Updates the date/time for later issuance
        SimTime = new Date();
    }
}
